function love.load()
require ("levels")
    love.graphics.setBackgroundColor(0, 1, .75)

    player = '@'
    playerbody= '1'
    player2 = 'x'
    player2body= '2'
    holz = '+'
    playerOnStorage = 's'
    player2OnStorage = 's2'
    player1bodyOnStorage="2o"
    box = '$'
    boxOnStorage = '*'
    storage = '.'
    wall = '#'
    empty = ' '
    obj1 = 'e'
    --obj2='2'

	currentplayer= "1"
    currentLevel = 1

  function loadLevel()
        level = {}
        for y, row in ipairs(levels[currentLevel]) do
            level[y] = {}
            for x, cell in ipairs(row) do
                level[y][x] = cell
            end
        end
    end

    loadLevel()
end

function love.keypressed(key)
    if key == 'up' or key == 'down' or key == 'left' or key == 'right' then
        local playerX
        local playerY
        local playerX2
        local playerY2
      
        for testY, row in ipairs(level) do
            for testX, cell in ipairs(row) do
                if cell == player then--or cell == player1body then --or cell == playerOnStorage then
                    playerX = testX
                    playerY = testY
                elseif cell == player2 then--or cell == player1body then --or cell == playerOnStorage then
                    playerX2 = testX
                    playerY2 = testY
                
                end
            end
        end
        
        local dx = 0
        local dy = 0
        if key == 'left' then
            dx = -1
        elseif key == 'right' then
            dx = 1
        elseif key == 'up' then
            dy = -1
        elseif key == 'down' then
            dy = 1
        end

        --player 1
        if currentplayer=="1" then
			local current = level[playerY][playerX]
			local adjacent = level[playerY + dy][playerX + dx]
			local beyond
			
				if level[playerY + dy + dy] then
					beyond = level[playerY + dy + dy][playerX + dx + dx]
				end
			

        local nextAdjacent = {
            [empty] = player,
            [storage] = playerOnStorage,
            [player] = player,
        }

        local nextCurrent = {
            [player] = empty,
            [storage] = storage,
        }

        local nextBeyond = {
            [empty] = box,
            [storage] = boxOnStorage,
        }

        local nextAdjacentPush = {
            [box] = player,
            [boxOnStorage] = playerOnStorage,
        }
        
        local nextBehind = {
			[player] = playerbody,
            [playerbody] = empty,
        }
      
        local nextBehind12 = {
			[player] = empty,
            [playerbody] = empty,
        }


        --the big fish occupies 6 cells and the small ocuppies 2:

        -- Looking to the left      Looking to the right	the @ represent the head
        --big fish		small		big fish	small
        
        --|@|X|X|		|@|X|		|X|X|@|		|X|@|
          -------				    -------
        --|X|X|X|					|X|X|X|
        

			if nextAdjacent[adjacent] then
				level[playerY][playerX] = nextCurrent[current]
				level[playerY -dy][playerX -dx] = nextBehind[current]
				level[playerY -dy -dy][playerX -dx -dx] = nextBehind12[current]
            
				level[playerY + dy][playerX + dx] = nextAdjacent[adjacent]

			elseif nextBeyond[beyond] and nextAdjacentPush[adjacent] then
				level[playerY][playerX] = nextCurrent[current]
				level[playerY + dy][playerX + dx] = nextAdjacentPush[adjacent]
				level[playerY + dy + dy][playerX + dx + dx] = nextBeyond[beyond]
			end
		end
		
		
		 --player 2
        if currentplayer=="2" then
			local current = level[playerY2][playerX2]
			local adjacent = level[playerY2 + dy][playerX2 + dx]
			local beyond
			local behind = level[playerY2 -dy][playerX2 - dx]
			
				if level[playerY2 + dy + dy] then
					beyond = level[playerY2 + dy + dy][playerX2 + dx + dx]
				end
        

        local nextAdjacent2 = {
            [empty] = player2,
            [storage] = player2OnStorage,
            [player2] = player2,
        }

        local nextCurrent2 = {
            [player2] = player2body,
            [player2body] = empty,
            [storage] = storage,
        }

        local nextBeyond2 = {
            [empty] = box,
            [storage] = boxOnStorage,
        }

        local nextAdjacentPush2 = {
            [box] = player2,
            [boxOnStorage] = player2OnStorage,
        }
        
        local nextBehind2 = {
			[player2] = player2body,
            [player2body] = empty,
        }
      
        local nextBehind22 = {
			[player2] = empty,
            [player2body] = empty,
        }
        
		
			if nextAdjacent2[adjacent] then
				level[playerY2][playerX2] = nextCurrent2[current]
				level[playerY2 -dy][playerX2 -dx] = nextBehind22[current]
            
				level[playerY2 + dy][playerX2 + dx] = nextAdjacent2[adjacent]

			elseif nextBeyond[beyond] and nextAdjacentPush[adjacent] then
				level[playerY2][playerX2] = nextCurrent2[current]
				level[playerY2 + dy][playerX2 + dx] = nextAdjacentPush2[adjacent]
				level[playerY2 + dy + dy][playerX2 + dx + dx] = nextBeyond2[beyond]
			end
		end
	

        --local complete = true

        for y, row in ipairs(level) do
            for x, cell in ipairs(row) do
                if cell == box then
                    complete = false
                end
            end
        end

        if complete then
            currentLevel = currentLevel + 1
            if currentLevel > #levels then
                currentLevel = 1
            end
            loadLevel()
        end
	
	elseif key == 'space' and currentplayer=="1" then
	currentplayer="2"
	elseif key == 'space' and currentplayer=="2" then
    currentplayer="1"    
    elseif key == 'r' then
        loadLevel()

    elseif key == 'n' then
        currentLevel = currentLevel + 1
        if currentLevel > #levels then
            currentLevel = 1
        end
        loadLevel()

    elseif key == 'p' then
        currentLevel = currentLevel - 1
        if currentLevel < 1 then
            currentLevel = #levels
        end
        loadLevel()
    end

end


function love.draw()
    for y, row in ipairs(level) do
        for x, cell in ipairs(row) do
            if cell ~= empty then
                local cellSize = 23

                               local colors = {
                    [player] = {0.64, 0.53, 1},
                    [playerbody] = {0.64, 0.53, 1},
                    [player2] = {0, 0, 1},
                    [player2body] = {0, 0, 1},
                    [holz] = {0.5, 0.5, 0},
                    [playerOnStorage] = {0.62, 0.47, 1},
                    [box] = {1, 0.79, 0.49},
                    [boxOnStorage] = {0.59, 1, 0.5},
                    [storage] = {0.61, 0.9, 1},
                    [wall] = {0.6, 0.58, 0.2},
                    [obj1] = {0.29,0.43,0.83},
                    --[obj2] = {0.9,0.43,0.83},
                    [empty] = {0.146, 0.73, 0.73},
                }

                love.graphics.setColor(colors[cell])
                love.graphics.rectangle(
                    'fill',
                    (x - 1) * cellSize,
                    (y - 1) * cellSize,
                    cellSize,
                    cellSize
                )
                love.graphics.setColor(1, 1, 1)
                love.graphics.print(
                    level[y][x],
                    (x - 1) * cellSize,
                    (y - 1) * cellSize
                )
            love.graphics.print("Current player:" ..currentplayer,50,50)
            love.graphics.print("Press space to switch characters:",300,50)
            end
        end
    end
end
